SystemOrganization addCategory: #'Mars-Cocoa-Base'!
SystemOrganization addCategory: #'Mars-Cocoa-View'!
SystemOrganization addCategory: #'Mars-Cocoa-Delegate'!

!Rectangle class methodsFor: '*mars-cocoa-extensions' stamp: 'EstebanLorenzano 1/21/2012 15:29'!
fromNSRect: anAlien
	^self 
		origin: (anAlien floatAt: 1) asInteger@(anAlien floatAt: 5) asInteger
		extent: (anAlien floatAt: 9) asInteger@(anAlien floatAt: 13) asInteger! !

!Rectangle methodsFor: '*mars-cocoa-extensions' stamp: 'EstebanLorenzano 1/21/2012 15:29'!
asNSRect
	self flag: #todo. "This should be a plain alien (I don't want to have a NS objects pollution)"
	^NSRect 
		x: self left
		y: self top
		width: self width 
		height: self height! !

!Rectangle methodsFor: '*mars-cocoa-extensions' stamp: 'EstebanLorenzano 1/22/2012 18:03'!
translateToFirstQuadrant: sizePoint 
	^self class
		origin: (self origin translateToFirstQuadrant: sizePoint) - (0@self height)
		extent: self extent! !

!Rectangle methodsFor: '*mars-cocoa-extensions' stamp: 'EstebanLorenzano 1/22/2012 18:02'!
translateToFourthQuadrant: sizePoint 
	^self class
		origin: (self origin translateToFourthQuadrant: sizePoint) + (0@self height)
		extent: self extent! !

MToolkit subclass: #CocoaToolkit
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mars-Cocoa-Base'!

!CocoaToolkit class methodsFor: 'as yet unclassified' stamp: 'EstebanLorenzano 2/2/2012 21:13'!
classFor: aClass
	^self environment at: ('Cocoa', aClass name allButFirst) asSymbol! !

!CocoaToolkit class methodsFor: 'as yet unclassified' stamp: 'EstebanLorenzano 2/2/2012 21:12'!
isActive
	^true! !

SharedPool subclass: #CocoaConstantPool
	instanceVariableNames: ''
	classVariableNames: 'NSAlertFirstButtonReturn NSAlertSecondButtonReturn NSAlertThirdButtonReturn NSAlphaShiftKeyMask NSAlternateKeyMask NSBackingStoreBuffered NSBackingStoreNonretained NSBackingStoreRetained NSBezelBorder NSBoldFontMask NSBorderlessWindowMask NSCircularBezelStyle NSClosableWindowMask NSCommandKeyMask NSCompressedFontMask NSCondensedFontMask NSControlKeyMask NSCriticalAlertStyle NSDeviceIndependentModifierFlagsMask NSDisclosureBezelStyle NSExpandedFontMask NSFixedPitchFontMask NSFunctionKeyMask NSGrooveBorder NSHelpButtonBezelStyle NSHelpKeyMask NSHighlightModeMatrix NSImageAbove NSImageBelow NSImageCellType NSImageLeft NSImageOnly NSImageOverlaps NSImageRight NSInformationalAlertStyle NSItalicFontMask NSLineBorder NSListModeMatrix NSMiniaturizableWindowMask NSMixedState NSMomentaryChangeButton NSMomentaryLight NSMomentaryLightButton NSMomentaryPushButton NSMomentaryPushInButton NSNarrowFontMask NSNoBorder NSNoImage NSNonStandardCharacterSetFontMask NSNotFound NSNullCellType NSNumericPadKeyMask NSOffState NSOnOffButton NSOnState NSPosterFontMask NSPushOnPushOffButton NSRadioButton NSRadioModeMatrix NSRecessedBezelStyle NSRegularSquareBezelStyle NSResizableWindowMask NSRoundRectBezelStyle NSRoundedBezelStyle NSRoundedDisclosureBezelStyle NSScaleNone NSScaleProportionally NSScaleToFit NSSegmentStyleAutomatic NSSegmentStyleCapsule NSSegmentStyleRoundRect NSSegmentStyleRounded NSSegmentStyleSmallSquare NSSegmentStyleTexturedRounded NSSegmentStyleTexturedSquare NSShadowlessSquareBezelStyle NSShiftKeyMask NSSmallCapsFontMask NSSmallSquareBezelStyle NSSplitViewDividerStylePaneSplitter NSSplitViewDividerStyleThick NSSplitViewDividerStyleThin NSSwitchButton NSTableViewFirstColumnOnlyAutoresizingStyle NSTableViewLastColumnOnlyAutoresizingStyle NSTableViewNoColumnAutoresizing NSTableViewReverseSequentialColumnAutoresizingStyle NSTableViewSequentialColumnAutoresizingStyle NSTableViewUniformColumnAutoresizingStyle NSTextCellType NSTextFieldRoundedBezel NSTextFieldSquareBezel NSTexturedBackgroundWindowMask NSTexturedRoundedBezelStyle NSTexturedSquareBezelStyle NSThickSquareBezelStyle NSThickerSquareBezelStyle NSTitledWindowMask NSToggleButton NSToolbarDisplayModeDefault NSToolbarDisplayModeIconAndLabel NSToolbarDisplayModeIconOnly NSToolbarDisplayModeLabelOnly NSToolbarSizeModeDefault NSToolbarSizeModeRegular NSToolbarSizeModeSmall NSTrackModeMatrix NSUnboldFontMask NSUnitalicFontMask NSViewHeightSizable NSViewMaxXMargin NSViewMaxYMargin NSViewMinXMargin NSViewMinYMargin NSViewNotSizable NSViewWidthSizable NSWarningAlertStyle NSWindowCloseButton NSWindowDocumentIconButton NSWindowMiniaturizeButton NSWindowToolbarButton NSWindowZoomButton'
	poolDictionaries: ''
	category: 'Mars-Cocoa-Base'!

!CocoaConstantPool class methodsFor: 'class initialization' stamp: 'EstebanLorenzano 1/21/2012 10:25'!
initialize
	super initialize.
	self initializeConstants.! !

!CocoaConstantPool class methodsFor: 'class initialization' stamp: 'EstebanLorenzano 1/21/2012 10:25'!
initializeButtonConstants 
! !

!CocoaConstantPool class methodsFor: 'class initialization' stamp: 'EstebanLorenzano 1/21/2012 10:25'!
initializeCellConstants 
	"Cell Types"
	NSNullCellType  := 0.
   	NSTextCellType  := 1.
   	NSImageCellType := 2.! !

!CocoaConstantPool class methodsFor: 'class initialization' stamp: 'EstebanLorenzano 1/21/2012 10:25'!
initializeConstants
 	"self initializeConstants"
	self initializeWindowConstants.
  	self initializeLayoutConstants. 	
	self initializeWidgetConstants.
	self initializeCellConstants.
	self initializeToolbarConstants.
	self initializeMenuConstants.
	self initializeErrorConstants.
	self initializeFontConstants.! !

!CocoaConstantPool class methodsFor: 'class initialization' stamp: 'EstebanLorenzano 1/21/2012 10:25'!
initializeErrorConstants 
	"NSError codes"
	NSNotFound := 16r7FFFFFFF.
! !

!CocoaConstantPool class methodsFor: 'class initialization' stamp: 'EstebanLorenzano 1/21/2012 10:25'!
initializeFontConstants 
	"Font traits"
	NSItalicFontMask 			:= 16r00000001.
  	NSBoldFontMask 			:= 16r00000002.
   	NSUnboldFontMask 		:= 16r00000004.
   	NSNonStandardCharacterSetFontMask 	:= 16r00000008.
   	NSNarrowFontMask 		:= 16r00000010.
   	NSExpandedFontMask 		:= 16r00000020.
   	NSCondensedFontMask 	:= 16r00000040.
   	NSSmallCapsFontMask 		:= 16r00000080.
   	NSPosterFontMask 			:= 16r00000100.
   	NSCompressedFontMask 	:= 16r00000200.
   	NSFixedPitchFontMask 		:= 16r00000400.
   	NSUnitalicFontMask 		:= 16r01000000.
! !

!CocoaConstantPool class methodsFor: 'class initialization' stamp: 'EstebanLorenzano 1/21/2012 10:25'!
initializeLayoutConstants
	"Layout constants"
    	NSViewNotSizable								:= 0.
    	NSViewMinXMargin								:= 1.
    	NSViewWidthSizable							:= 2.
    	NSViewMaxXMargin								:= 4.
    	NSViewMinYMargin								:= 8.
    	NSViewHeightSizable							:= 16.
    	NSViewMaxYMargin								:= 32.
	"Table autoresizing options"
 	NSTableViewNoColumnAutoresizing 				:= 0.
   	NSTableViewUniformColumnAutoresizingStyle 		:= 1.
   	NSTableViewSequentialColumnAutoresizingStyle 	:= 2.
   	NSTableViewReverseSequentialColumnAutoresizingStyle := 3.
   	NSTableViewLastColumnOnlyAutoresizingStyle 	:= 4.
   	NSTableViewFirstColumnOnlyAutoresizingStyle 	:= 5.
	! !

!CocoaConstantPool class methodsFor: 'class initialization' stamp: 'EstebanLorenzano 1/21/2012 10:25'!
initializeMenuConstants 
	"Key masks (for menus)"
	NSAlphaShiftKeyMask := 1 << 16.
	NSShiftKeyMask := 1 << 17.
	NSControlKeyMask := 1 << 18.
	NSAlternateKeyMask := 1 << 19.
	NSCommandKeyMask := 1 << 20.
	NSNumericPadKeyMask := 1 << 21.
	NSHelpKeyMask := 1 << 22.
	NSFunctionKeyMask := 1 << 23.
	NSDeviceIndependentModifierFlagsMask := 16rFFFF0000	! !

!CocoaConstantPool class methodsFor: 'class initialization' stamp: 'EstebanLorenzano 1/21/2012 10:25'!
initializeToolbarConstants 
	"Toolbar display types"
 	NSToolbarDisplayModeDefault := 0.
	NSToolbarDisplayModeIconAndLabel := 1.
	NSToolbarDisplayModeIconOnly := 2.
	NSToolbarDisplayModeLabelOnly := 3.
	"Size modes"
 	NSToolbarSizeModeDefault := 0.
   	NSToolbarSizeModeRegular := 1.
   	NSToolbarSizeModeSmall := 2.
! !

!CocoaConstantPool class methodsFor: 'class initialization' stamp: 'EstebanLorenzano 1/21/2012 10:25'!
initializeWidgetConstants 
	"Button states"
	NSOffState := 0.
	NSOnState := 1.
	NSMixedState := -1.
	"Bezel types"
 	NSRoundedBezelStyle           	:= 1.
   	NSRegularSquareBezelStyle     	:= 2.
   	NSThickSquareBezelStyle       	:= 3.
   	NSThickerSquareBezelStyle     	:= 4.
   	NSDisclosureBezelStyle        	:= 5.
   	NSShadowlessSquareBezelStyle  := 6.
   	NSCircularBezelStyle          		:= 7.
   	NSTexturedSquareBezelStyle   := 8.
   	NSHelpButtonBezelStyle        	:= 9.
   	NSSmallSquareBezelStyle       	:= 10.
   	NSTexturedRoundedBezelStyle := 11.
   	NSRoundRectBezelStyle         	:= 12.
   	NSRecessedBezelStyle          	:= 13.
   	NSRoundedDisclosureBezelStyle := 14.
	"Button types"
   	NSMomentaryLightButton   		:= 0.
   	NSPushOnPushOffButton    		:= 1.
   	NSToggleButton           			:= 2.
   	NSSwitchButton           			:= 3.
   	NSRadioButton            			:= 4.
   	NSMomentaryChangeButton 	:= 5.
   	NSOnOffButton            			:= 6.
   	NSMomentaryPushInButton  	:= 7.
   	NSMomentaryPushButton    	:= 0.
   	NSMomentaryLight         		:= 7.
	"Matrix states"
	NSRadioModeMatrix := 0.
   	NSHighlightModeMatrix := 1.
   	NSListModeMatrix := 2.
   	NSTrackModeMatrix := 3.
	"Borders"
	NSNoBorder := 0.
   	NSLineBorder := 1.
   	NSBezelBorder := 2.
   	NSGrooveBorder := 3.
	"Split divider styles"
 	NSSplitViewDividerStyleThick := 1.
   	NSSplitViewDividerStyleThin := 2.
   	NSSplitViewDividerStylePaneSplitter := 3.
	"TextField bezel style"
	NSTextFieldSquareBezel  := 0.
	NSTextFieldRoundedBezel := 1.
	"Button image position"
 	NSNoImage       			:= 0.
   	NSImageOnly    			:= 1.
   	NSImageLeft     			:= 2.
   	NSImageRight    			:= 3.
   	NSImageBelow    			:= 4.
   	NSImageAbove    			:= 5.
   	NSImageOverlaps 			:= 6	.
	"Segmented control"
	NSSegmentStyleAutomatic 				:= 0.
   	NSSegmentStyleRounded 				:= 1.
   	NSSegmentStyleTexturedRounded 		:= 2.
   	NSSegmentStyleRoundRect 			:= 3.
   	NSSegmentStyleTexturedSquare 		:= 4.
   	NSSegmentStyleCapsule 				:= 5.
   	NSSegmentStyleSmallSquare 			:= 6.
	"Image"
	NSScaleProportionally 					:= 0.
	NSScaleToFit 							:= 1.
	NSScaleNone 							:= 2.
! !

!CocoaConstantPool class methodsFor: 'class initialization' stamp: 'EstebanLorenzano 1/21/2012 10:25'!
initializeWindowConstants 
	"Window style mask constants"
	NSBorderlessWindowMask 				:= 0.
 	NSTitledWindowMask 					:= 1 << 0.
	NSClosableWindowMask 				:= 1 << 1.
	NSMiniaturizableWindowMask 			:= 1 << 2.
	NSResizableWindowMask 				:= 1 << 3.
	NSTexturedBackgroundWindowMask 	:= 1 << 8.
	"NSBackingStoreType - Buffered Window Drawing"
	NSBackingStoreRetained     			:= 0.
	NSBackingStoreNonretained  			:= 1.
	NSBackingStoreBuffered     			:= 2.
	"Window buttons"
	NSWindowCloseButton 					:= 0.
	NSWindowMiniaturizeButton 			:= 1.
	NSWindowZoomButton 				:= 2.
	NSWindowToolbarButton 				:= 3.
	NSWindowDocumentIconButton 		:= 4.
	"Alert styles"
 	NSWarningAlertStyle 					:= 0.
   	NSInformationalAlertStyle 				:= 1.
   	NSCriticalAlertStyle 					:= 2.
	"Alert buttons"
	NSAlertFirstButtonReturn  				:= 1000.
   	NSAlertSecondButtonReturn  			:= 1001.
   	NSAlertThirdButtonReturn  				:= 1002.! !

!CocoaConstantPool class methodsFor: 'accessing' stamp: 'EstebanLorenzano 1/21/2012 10:25'!
valueOf: varName
	^(self bindingOf: varName) value! !

!Point methodsFor: '*mars-cocoa-extensions' stamp: 'EstebanLorenzano 1/22/2012 18:03'!
translateToFirstQuadrant: sizePoint
	^self class 
		x: self x
		y: sizePoint y - self y	
	! !

!Point methodsFor: '*mars-cocoa-extensions' stamp: 'EstebanLorenzano 1/22/2012 18:03'!
translateToFourthQuadrant: sizePoint
	^self class 
		x: self x
		y: sizePoint y - self y! !

!Boolean class methodsFor: '*mars-cocoa-extensions' stamp: 'EstebanLorenzano 1/21/2012 15:34'!
fromNumber: aNumber
	^aNumber == 1! !

Object subclass: #CocoaApplication
	instanceVariableNames: 'registeredWindows'
	classVariableNames: 'Current'
	poolDictionaries: ''
	category: 'Mars-Cocoa-Base'!

!CocoaApplication class methodsFor: 'as yet unclassified' stamp: 'EstebanLorenzano 1/21/2012 16:21'!
current 
	^Current ifNil: [ self run ]! !

!CocoaApplication class methodsFor: 'as yet unclassified' stamp: 'EstebanLorenzano 1/21/2012 16:21'!
new
	self error: 'Invalid invocation, my subclasses should be executed by calling #run'! !

!CocoaApplication class methodsFor: 'as yet unclassified' stamp: 'EstebanLorenzano 1/21/2012 16:21'!
reset 
	Current := nil.! !

!CocoaApplication class methodsFor: 'as yet unclassified' stamp: 'EstebanLorenzano 1/21/2012 16:21'!
run
	Current ifNotNil: [ self reset ].
	Current := super new.
	Current run.
	^Current! !

!CocoaApplication methodsFor: 'as yet unclassified' stamp: 'EstebanLorenzano 1/21/2012 16:21'!
initialize
	super initialize.
	registeredWindows := Set new.! !

!CocoaApplication methodsFor: 'as yet unclassified' stamp: 'EstebanLorenzano 1/21/2012 16:21'!
registerWindow: aWindow
	registeredWindows add: aWindow.! !

!CocoaApplication methodsFor: 'as yet unclassified' stamp: 'EstebanLorenzano 1/21/2012 16:22'!
run! !

!CocoaApplication methodsFor: 'as yet unclassified' stamp: 'EstebanLorenzano 1/22/2012 17:14'!
unregisterWindow: aWindow
	registeredWindows remove: aWindow.
	"Ensure window is released (all memory is released)"
	"aWindow release."! !

Object subclass: #CocoaAutoreleasePool
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mars-Cocoa-Base'!

CocoaAutoreleasePool class
	instanceVariableNames: 'pool count'!

CocoaAutoreleasePool class
	instanceVariableNames: 'pool count'!

!CocoaAutoreleasePool class methodsFor: 'as yet unclassified' stamp: 'EstebanLorenzano 1/21/2012 15:27'!
do: aBlock 
	[ self init. 
	  ^aBlock value ]
	ensure: [ self release ]  ! !

!CocoaAutoreleasePool class methodsFor: 'as yet unclassified' stamp: 'EstebanLorenzano 1/21/2012 15:27'!
init 
	count ifNil: [ count := 0 ].
	count = 0 ifTrue: [
		count := count + 1.
		pool := 'NSAutoreleasePool' inObjectiveC alloc init ].
	! !

!CocoaAutoreleasePool class methodsFor: 'as yet unclassified' stamp: 'EstebanLorenzano 1/21/2012 15:27'!
release
	count := count - 1.
	count = 0 ifTrue: [
 		pool drain.
		pool := nil.
		count := nil ]! !

Object subclass: #CocoaDelegate
	instanceVariableNames: 'owner proxy'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mars-Cocoa-Delegate'!

!CocoaDelegate class methodsFor: 'instance creation' stamp: 'EstebanLorenzano 1/21/2012 15:59'!
for: anObject
	^self basicNew 
		initialize: anObject;
		yourself! !

!CocoaDelegate class methodsFor: 'instance creation' stamp: 'EstebanLorenzano 1/21/2012 15:59'!
new 
	self error: 'Use #for:'! !

!CocoaDelegate methodsFor: 'accessing' stamp: 'EstebanLorenzano 1/21/2012 16:00'!
externalHandle 
	^proxy proxy! !

!CocoaDelegate methodsFor: 'initialization' stamp: 'EstebanLorenzano 1/21/2012 16:00'!
initialize 
	super initialize.
	proxy := ObjectiveCSmalltalkProxyClass instanceFor: self! !

!CocoaDelegate methodsFor: 'initialization' stamp: 'EstebanLorenzano 1/21/2012 15:58'!
initialize: aView
	owner := aView.
	self initialize.! !

!CocoaDelegate methodsFor: 'accessing' stamp: 'EstebanLorenzano 1/21/2012 15:58'!
owner 
	^owner! !

CocoaDelegate subclass: #CocoaWindowDelegate
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mars-Cocoa-Delegate'!

!CocoaWindowDelegate methodsFor: 'delegates' stamp: 'EstebanLorenzano 1/21/2012 16:06'!
"(BOOL)"windowShouldClose:"(id)"sender
	<objectiveCSignature: 'i@:@'>	
	^true asAlien! !

!CocoaWindowDelegate methodsFor: 'delegates' stamp: 'EstebanLorenzano 1/21/2012 16:23'!
"(void)"windowWillClose:"(NSNotification *)"notification
	<objectiveCSignature: 'v@:@'>
	self owner unregister.
	^nil asAlien! !

Object subclass: #CocoaView
	uses: TMAnnouncer
	instanceVariableNames: 'externalHandle deferredActions parent announcer'
	classVariableNames: ''
	poolDictionaries: 'CocoaConstantPool'
	category: 'Mars-Cocoa-View'!

CocoaView class
	uses: TMAnnouncer classTrait
	instanceVariableNames: ''!

CocoaView subclass: #CocoaContainer
	instanceVariableNames: 'children layoutPolicy'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mars-Cocoa-View'!

!CocoaContainer class methodsFor: 'as yet unclassified' stamp: 'EstebanLorenzano 2/3/2012 00:48'!
defaultLayoutPolicy 
	^MFixedLayout new! !

!CocoaContainer class methodsFor: 'instance creation' stamp: 'EstebanLorenzano 2/3/2012 01:03'!
with: anObject 
	"Answer an instance of me containing anObject."

	^ self new
		add: anObject;
		yourself! !

!CocoaContainer class methodsFor: 'instance creation' stamp: 'EstebanLorenzano 2/3/2012 01:03'!
with: firstObject with: secondObject 
	"Answer an instance of me containing the two arguments as elements."

	^ self new
		add: firstObject;
		add: secondObject;
		yourself! !

!CocoaContainer class methodsFor: 'instance creation' stamp: 'EstebanLorenzano 2/3/2012 01:03'!
with: firstObject with: secondObject with: thirdObject 
	"Answer an instance of me containing the three arguments as elements."

	^ self new
		add: firstObject;
		add: secondObject;
		add: thirdObject;
		yourself! !

!CocoaContainer class methodsFor: 'instance creation' stamp: 'EstebanLorenzano 2/3/2012 01:04'!
with: firstObject with: secondObject with: thirdObject with: fourthObject 
	"Answer an instance of me, containing the four arguments as the elements."

	^ self new
		add: firstObject;
		add: secondObject;
		add: thirdObject;
		add: fourthObject;
		yourself! !

!CocoaContainer class methodsFor: 'instance creation' stamp: 'EstebanLorenzano 2/3/2012 01:04'!
with: firstObject with: secondObject with: thirdObject with: fourthObject with: fifthObject
	"Answer an instance of me, containing the five arguments as the elements."

	^ self new
		add: firstObject;
		add: secondObject;
		add: thirdObject;
		add: fourthObject;
		add: fifthObject;
		yourself! !

!CocoaContainer class methodsFor: 'instance creation' stamp: 'EstebanLorenzano 2/3/2012 01:04'!
with: firstObject with: secondObject with: thirdObject with: fourthObject with: fifthObject with: sixthObject
	"Answer an instance of me, containing the six arguments as the elements."

	^ self new
		add: firstObject;
		add: secondObject;
		add: thirdObject;
		add: fourthObject;
		add: fifthObject;
		add: sixthObject;
		yourself! !

!CocoaContainer class methodsFor: 'instance creation' stamp: 'EstebanLorenzano 2/3/2012 01:04'!
withAll: aCollection
	"Create a new collection containing all the elements from aCollection."

	^ self new
		addAll: aCollection;
		yourself! !

!CocoaContainer methodsFor: 'accessing' stamp: 'EstebanLorenzano 1/21/2012 15:19'!
add: aView
	self assert: aView isEmbedable 
		description: 'Just embedable views can be added to a container'.
	
	aView parent: self.
	self children add: aView.
	self embedView: aView.
	
	^aView! !

!CocoaContainer methodsFor: 'accessing' stamp: 'EstebanLorenzano 1/21/2012 15:20'!
addAll: aCollection
	aCollection do: [ :each | self add: each ].
	^aCollection! !

!CocoaContainer methodsFor: 'accessing' stamp: 'EstebanLorenzano 1/21/2012 15:22'!
children 
	^children ifNil: [ children := OrderedCollection new ]! !

!CocoaContainer methodsFor: 'private' stamp: 'EstebanLorenzano 1/21/2012 15:36'!
deepPerformDeferredActions 
	super deepPerformDeferredActions.
	self children do: #deepPerformDeferredActions.! !

!CocoaContainer methodsFor: 'private' stamp: 'EstebanLorenzano 1/21/2012 15:22'!
embedView: aView   
	self externalHandle addSubview: aView externalHandle! !

!CocoaContainer methodsFor: 'initialization' stamp: 'EstebanLorenzano 1/21/2012 15:19'!
initialize 
	super initialize.
	self initializeContents! !

!CocoaContainer methodsFor: 'initialization' stamp: 'EstebanLorenzano 1/21/2012 15:23'!
initializeContents! !

!CocoaContainer methodsFor: 'private' stamp: 'EstebanLorenzano 1/21/2012 15:21'!
internalRemove: aView   
	aView externalHandle removeFromSuperview.
	self externalHandle setNeedsDisplay: true asAlien! !

!CocoaContainer methodsFor: 'private' stamp: 'EstebanLorenzano 1/21/2012 15:21'!
internalRemoveAll
	self children do: [ :each | each externalHandle removeFromSuperview ].
! !

!CocoaContainer methodsFor: 'private' stamp: 'EstebanLorenzano 2/3/2012 00:55'!
layoutChanged 
	self executeActionOrDeferUntilEmbedded: [ self layoutPolicy applyLayout: self ].! !

!CocoaContainer methodsFor: 'accessing' stamp: 'EstebanLorenzano 2/3/2012 00:48'!
layoutPolicy
	^layoutPolicy ifNil: [ layoutPolicy := self class defaultLayoutPolicy  ]! !

!CocoaContainer methodsFor: 'accessing' stamp: 'EstebanLorenzano 2/3/2012 00:55'!
layoutPolicy: aLayoutPolicy
	layoutPolicy := aLayoutPolicy.
	self layoutChanged.! !

!CocoaContainer methodsFor: 'accessing' stamp: 'EstebanLorenzano 1/21/2012 15:20'!
remove: aView 
	self children remove: aView.
	self internalRemove: aView.! !

!CocoaContainer methodsFor: 'accessing' stamp: 'EstebanLorenzano 1/21/2012 15:21'!
removeAll 
	children := OrderedCollection new.
	self internalRemoveAll! !

CocoaContainer subclass: #CocoaScroller
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mars-Cocoa-View'!

!CocoaScroller methodsFor: 'accessing' stamp: 'EstebanLorenzano 2/3/2012 01:07'!
add: aView
	self assert: self children isEmptyOrNil description: 'Scroller allows just one child'.
	^super add: aView! !

!CocoaScroller methodsFor: 'private' stamp: 'EstebanLorenzano 2/3/2012 01:01'!
autohide: aBoolean
	self externalHandle setAutohidesScrollers: aBoolean asAlien! !

!CocoaScroller methodsFor: 'accessing' stamp: 'EstebanLorenzano 2/3/2012 01:02'!
beAutohide
	self autohide: true! !

!CocoaScroller methodsFor: 'accessing' stamp: 'EstebanLorenzano 2/3/2012 01:02'!
beHorizontal
	self horizontal: true! !

!CocoaScroller methodsFor: 'accessing' stamp: 'EstebanLorenzano 2/3/2012 01:02'!
beHorizontalAndVertical
	self beHorizontal.
	self beVertical.! !

!CocoaScroller methodsFor: 'accessing' stamp: 'EstebanLorenzano 2/3/2012 01:02'!
beNotAutohide
	self autohide: false! !

!CocoaScroller methodsFor: 'accessing' stamp: 'EstebanLorenzano 2/3/2012 01:02'!
beNotHorizontal
	self horizontal: false! !

!CocoaScroller methodsFor: 'accessing' stamp: 'EstebanLorenzano 2/3/2012 01:02'!
beNotVertical
	self vertical: false.! !

!CocoaScroller methodsFor: 'accessing' stamp: 'EstebanLorenzano 2/3/2012 01:02'!
beVertical
	self vertical: true.! !

!CocoaScroller methodsFor: 'accessing' stamp: 'EstebanLorenzano 2/3/2012 01:02'!
content
	^self children 
		ifNotEmpty: [ self children first ]
		ifEmpty: [ nil ]! !

!CocoaScroller methodsFor: 'accessing' stamp: 'EstebanLorenzano 2/3/2012 01:02'!
content: aView
	self removeAll.
	self add: aView.! !

!CocoaScroller methodsFor: 'initialization' stamp: 'EstebanLorenzano 2/3/2012 01:01'!
createExternalHandle 
	^'NSScrollView' inObjectiveC alloc 
		initWithFrame: (0@0 corner: 1@1) asNSRect! !

!CocoaScroller methodsFor: 'private' stamp: 'EstebanLorenzano 2/3/2012 01:01'!
embedView: aView 
	self externalHandle setDocumentView: aView externalHandle! !

!CocoaScroller methodsFor: 'private' stamp: 'EstebanLorenzano 2/3/2012 01:01'!
horizontal: aBoolean 
	self externalHandle setHasHorizontalScroller: aBoolean asAlien! !

!CocoaScroller methodsFor: 'initialization' stamp: 'EstebanLorenzano 2/3/2012 01:01'!
initialize
	super initialize.
	self beAutohide.
	self beHorizontalAndVertical ! !

!CocoaScroller methodsFor: 'private' stamp: 'EstebanLorenzano 2/3/2012 01:01'!
vertical: aBoolean
	self externalHandle setHasVerticalScroller: aBoolean asAlien! !

CocoaContainer subclass: #CocoaSplitter
	instanceVariableNames: 'delegate'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mars-Cocoa-View'!

!CocoaSplitter methodsFor: 'accessing' stamp: 'EstebanLorenzano 2/3/2012 00:45'!
beHorizontal 
	self vertical: false! !

!CocoaSplitter methodsFor: 'accessing' stamp: 'EstebanLorenzano 2/3/2012 00:45'!
beVertical
	self vertical: true! !

!CocoaSplitter methodsFor: 'private' stamp: 'EstebanLorenzano 2/3/2012 00:45'!
createExternalHandle 
	^'NSSplitView' inObjectiveC alloc 
		initWithFrame: (0@0 corner: 1@1) asNSRect! !

!CocoaSplitter methodsFor: 'testing' stamp: 'EstebanLorenzano 2/3/2012 00:46'!
isHorizontal 
	^self isVertical not! !

!CocoaSplitter methodsFor: 'testing' stamp: 'EstebanLorenzano 2/3/2012 00:46'!
isVertical 
	^Boolean fromNumber: self externalHandle isVertical! !

!CocoaSplitter methodsFor: 'private' stamp: 'EstebanLorenzano 2/3/2012 00:45'!
vertical: aBoolean
	self externalHandle setVertical: aBoolean asAlien! !

CocoaContainer subclass: #CocoaWindow
	instanceVariableNames: 'delegate'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mars-Cocoa-View'!

!CocoaWindow class methodsFor: 'defaults' stamp: 'EstebanLorenzano 1/21/2012 15:25'!
defaultBacking 
	^NSBackingStoreBuffered! !

!CocoaWindow class methodsFor: 'defaults' stamp: 'EstebanLorenzano 1/21/2012 15:25'!
defaultStyleMask 
	^NSTitledWindowMask 
		| NSClosableWindowMask 
		| NSMiniaturizableWindowMask 
		| NSResizableWindowMask
! !

!CocoaWindow methodsFor: 'geometry' stamp: 'EstebanLorenzano 1/22/2012 18:05'!
bounds  
	| size |
	size := (Rectangle fromNSRect: ('NSScreen' inObjectiveC mainScreen frame)) corner.

	^(Rectangle fromNSRect: self externalHandle contentView bounds) 
		translateToFourthQuadrant: size! !

!CocoaWindow methodsFor: 'geometry' stamp: 'EstebanLorenzano 1/22/2012 18:05'!
bounds: aRectangle
	| size |
	size := (Rectangle fromNSRect: ('NSScreen' inObjectiveC mainScreen frame)) corner.
	self externalHandle
		setFrame: (aRectangle translateToFirstQuadrant: size) asNSRect 
		display: true asAlien! !

!CocoaWindow methodsFor: 'showing' stamp: 'EstebanLorenzano 1/21/2012 15:30'!
center 
	self externalHandle center! !

!CocoaWindow methodsFor: 'showing' stamp: 'EstebanLorenzano 1/22/2012 18:24'!
close 
	self externalHandle close! !

!CocoaWindow methodsFor: 'private' stamp: 'EstebanLorenzano 1/21/2012 15:23'!
createExternalHandle 
	^'NSWindow' inObjectiveC alloc 
		initWithContentRect: (0@0 corner: 0@0) asNSRect 
		styleMask: self class defaultStyleMask
		backing: self class defaultBacking
		defer: false asAlien! !

!CocoaWindow methodsFor: 'private' stamp: 'EstebanLorenzano 1/21/2012 15:58'!
delegate 
	^delegate ifNil: [ delegate := CocoaWindowDelegate for: self ]! !

!CocoaWindow methodsFor: 'private' stamp: 'EstebanLorenzano 1/21/2012 15:30'!
embedView: aView 
	self externalHandle contentView addSubview: aView externalHandle    ! !

!CocoaWindow methodsFor: 'initialization' stamp: 'EstebanLorenzano 1/21/2012 16:18'!
initialize 
	super initialize.
	self externalHandle 
		setDelegate: self delegate externalHandle! !

!CocoaWindow methodsFor: 'private' stamp: 'EstebanLorenzano 1/21/2012 15:30'!
internalShow 
	self externalHandle makeKeyAndOrderFront: nil asAlien ! !

!CocoaWindow methodsFor: 'testing' stamp: 'EstebanLorenzano 1/21/2012 15:22'!
isEmbedable
	^false! !

!CocoaWindow methodsFor: 'testing' stamp: 'EstebanLorenzano 1/21/2012 17:56'!
isVisible
	^ Boolean fromNumber: self externalHandle isVisible! !

!CocoaWindow methodsFor: 'registering' stamp: 'EstebanLorenzano 1/21/2012 16:20'!
register
	CocoaApplication current registerWindow: self.! !

!CocoaWindow methodsFor: 'showing' stamp: 'EstebanLorenzano 1/21/2012 16:19'!
show 
	"self layoutChanged."
	self deepPerformDeferredActions.
	self register.
	self internalShow! !

!CocoaWindow methodsFor: 'accessing' stamp: 'EstebanLorenzano 1/21/2012 15:25'!
title
	^String fromNSString: self externalHandle title! !

!CocoaWindow methodsFor: 'accessing' stamp: 'EstebanLorenzano 1/21/2012 15:27'!
title: aString 
	CocoaAutoreleasePool 
		do: [ self externalHandle setTitle: aString asNSString autorelease ]! !

!CocoaWindow methodsFor: 'registering' stamp: 'EstebanLorenzano 1/21/2012 16:20'!
unregister
	CocoaApplication current unregisterWindow: self.! !

!CocoaView class methodsFor: 'as yet unclassified' stamp: 'EstebanLorenzano 1/22/2012 17:11'!
browserIcon
	^ #morph! !

!CocoaView methodsFor: 'announcing' stamp: 'EstebanLorenzano 2/2/2012 21:21'!
announcer 
	^announcer ifNil: [ announcer := Announcer new ]! !

!CocoaView methodsFor: 'geometry' stamp: 'EstebanLorenzano 1/22/2012 18:04'!
bounds
	^(Rectangle fromNSRect: self externalHandle frame) 
		translateToFourthQuadrant: self parent extent! !

!CocoaView methodsFor: 'geometry' stamp: 'EstebanLorenzano 1/22/2012 18:06'!
bounds: aRectangle
	"Sets the bounds for a view. 
	 There is a Cocoa design issue for this: the frame of the view is defined referred to it's 
	 parent. For that reason, if the view is not attached to parent, the set of this property
	 is deferrer until the view is attached. 
	 All the views are part of a window, and MRWindow has a diferent logic, so this shouldn't 
	 cause any problem"
	self executeActionOrDeferUntilEmbedded: [ 
		self externalHandle 
			setFrame: (aRectangle translateToFirstQuadrant: self parent extent) asNSRect ].  ! !

!CocoaView methodsFor: 'private' stamp: 'EstebanLorenzano 1/21/2012 09:28'!
createExternalHandle
	^self subclassResponsibility! !

!CocoaView methodsFor: 'private' stamp: 'EstebanLorenzano 1/21/2012 15:32'!
deepPerformDeferredActions
	self performDeferredActions! !

!CocoaView methodsFor: 'private' stamp: 'EstebanLorenzano 1/22/2012 17:26'!
deferAction: aBlock
	"Adds a block as a deferred action (it needs to be execute in the future)"
	deferredActions ifNil: [ deferredActions := OrderedCollection new ].
	deferredActions add: aBlock.! !

!CocoaView methodsFor: 'private' stamp: 'EstebanLorenzano 1/21/2012 15:33'!
executeActionOrDeferUntilEmbedded: aBlock
	"Some actions need to be deferred until the view is embeded. This is because some actions 
	 (for example set bounds related to a parent) needs to have a parent defined before been executed"
	self isEmbedded 
		ifTrue: aBlock
		ifFalse: [ self deferAction: aBlock ]! !

!CocoaView methodsFor: 'geometry' stamp: 'EstebanLorenzano 1/21/2012 15:31'!
extent 
	^self bounds extent! !

!CocoaView methodsFor: 'geometry' stamp: 'EstebanLorenzano 1/21/2012 15:31'!
extent: aPoint 
	self bounds: (self bounds origin extent: aPoint)! !

!CocoaView methodsFor: 'accessing' stamp: 'EstebanLorenzano 1/21/2012 15:21'!
externalHandle 
	^externalHandle! !

!CocoaView methodsFor: 'geometry' stamp: 'EstebanLorenzano 1/21/2012 15:31'!
height 
	^self bounds height! !

!CocoaView methodsFor: 'geometry' stamp: 'EstebanLorenzano 1/21/2012 15:31'!
height: aNumber 
	^self extent: (self width @ aNumber)! !

!CocoaView methodsFor: 'initialization' stamp: 'EstebanLorenzano 1/21/2012 15:17'!
initialize 
	super initialize.
	externalHandle := self createExternalHandle.! !

!CocoaView methodsFor: 'testing' stamp: 'EstebanLorenzano 1/21/2012 15:22'!
isEmbedable
	^true! !

!CocoaView methodsFor: 'testing' stamp: 'EstebanLorenzano 1/21/2012 15:33'!
isEmbedded 
	^self parent notNil! !

!CocoaView methodsFor: 'testing' stamp: 'EstebanLorenzano 1/21/2012 15:33'!
isRoot 
	^self parent isNil! !

!CocoaView methodsFor: 'testing' stamp: 'EstebanLorenzano 1/21/2012 15:33'!
isView
	^true! !

!CocoaView methodsFor: 'testing' stamp: 'EstebanLorenzano 1/21/2012 15:33'!
isVisible 
	^(Boolean fromNumber: self externalHandle isHidden) not! !

!CocoaView methodsFor: 'geometry' stamp: 'EstebanLorenzano 1/21/2012 15:32'!
left
	^self position x! !

!CocoaView methodsFor: 'geometry' stamp: 'EstebanLorenzano 1/21/2012 15:32'!
left: aNumber
	self position: (aNumber @ self top)! !

!CocoaView methodsFor: 'accessing' stamp: 'EstebanLorenzano 1/22/2012 17:26'!
parent
	^parent! !

!CocoaView methodsFor: 'accessing' stamp: 'EstebanLorenzano 1/22/2012 17:26'!
parent: aView
	parent := aView! !

!CocoaView methodsFor: 'private' stamp: 'EstebanLorenzano 1/21/2012 15:33'!
performDeferredActions
	"If there is any deferred action waiting to be executed, I perform the task. 
	 I dispose the #deferredActions attribute so the cycle can restart clean"
	deferredActions ifNotNil: [ 
		deferredActions do: #value.
		deferredActions := nil ]! !

!CocoaView methodsFor: 'geometry' stamp: 'EstebanLorenzano 1/21/2012 15:32'!
position
	^ self bounds bottomLeft! !

!CocoaView methodsFor: 'geometry' stamp: 'EstebanLorenzano 1/21/2012 15:32'!
position: aPoint
	self bounds: (aPoint extent: self extent)! !

!CocoaView methodsFor: 'geometry' stamp: 'EstebanLorenzano 1/21/2012 15:32'!
top 
	^self position y! !

!CocoaView methodsFor: 'geometry' stamp: 'EstebanLorenzano 1/21/2012 15:32'!
top: aNumber
	self position: (self left @ aNumber)! !

!CocoaView methodsFor: 'geometry' stamp: 'EstebanLorenzano 1/21/2012 15:32'!
width 
	^self bounds width! !

!CocoaView methodsFor: 'geometry' stamp: 'EstebanLorenzano 1/21/2012 15:32'!
width: aNumber 
	^self extent: (aNumber @ self height)! !

CocoaView subclass: #CocoaWidget
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mars-Cocoa-View'!

CocoaWidget subclass: #CocoaButton
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mars-Cocoa-View'!

!CocoaButton class methodsFor: 'accessing' stamp: 'EstebanLorenzano 1/22/2012 17:23'!
cocoaClassName 
	^'NSButton'! !

!CocoaButton methodsFor: 'accessing' stamp: 'EstebanLorenzano 1/22/2012 17:24'!
label 
	^String fromNSString: self externalHandle title! !

!CocoaButton methodsFor: 'accessing' stamp: 'EstebanLorenzano 1/22/2012 17:25'!
label: aString 
	CocoaAutoreleasePool 
		do: [ self externalHandle setTitle: aString asNSString autorelease ]! !

CocoaWidget subclass: #CocoaTable
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mars-Cocoa-View'!

CocoaTable subclass: #CocoaList
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mars-Cocoa-View'!

!CocoaList methodsFor: 'initialization' stamp: 'EstebanLorenzano 2/3/2012 01:14'!
initialize 
	super initialize.
	self externalHandle setHeaderView: nil asAlien.! !

!CocoaTable class methodsFor: 'accessing' stamp: 'EstebanLorenzano 2/3/2012 01:15'!
cocoaClassName 
	^'NSTableView'! !

CocoaWidget subclass: #CocoaText
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mars-Cocoa-View'!

CocoaText subclass: #CocoaTextArea
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mars-Cocoa-View'!

!CocoaTextArea class methodsFor: 'accessing' stamp: 'EstebanLorenzano 2/3/2012 00:57'!
cocoaClassName 
	^'NSTextView'! !

!CocoaWidget class methodsFor: 'accessing' stamp: 'EstebanLorenzano 1/22/2012 17:22'!
cocoaClassName 
	^self subclassResponsibility! !

!CocoaWidget methodsFor: 'private' stamp: 'EstebanLorenzano 1/22/2012 17:22'!
createExternalHandle 
	^self class cocoaClassName inObjectiveC alloc 
		initWithFrame: (0@0 corner: 1@1) asNSRect! !

!String class methodsFor: '*mars-cocoa-extensions' stamp: 'EstebanLorenzano 1/21/2012 15:26'!
fromNSString: aNSString
	^aNSString UTF8String strcpy! !
CocoaConstantPool initialize!
